/* GSI - general sound interface
 *
 * gsi_shm.h
 *
 *
 * 1996 - 2001 by W.H.Scholten
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__gsi__gsi_shm_h
#define _GSI__gsi__gsi_shm_h


#if USE_SHARED_MEMORY
#define GSI_SHM_ID  "GSI (C) 1998-2000 WHS" /* anything really to identify */
#define GSI_SHM_ID_SIZE (strlen(GSI_ID)+1)
#define GSI_SHM_BLOCK_SIZE sizeof(struct gsi_shm_block)
#define GSI_SHM_HEADER_SIZE sizeof(struct gsi_shm)

#if HAVE_POSIX_SHARED_MEMORY
#include <semaphore.h>
#endif
typedef struct gsi_shm {
	char id_string[16];
	int  shmid;

	int  header_size; /* size of this struct */
	int  data_size;   /* number of bytes for the sound data */

	/* reading/writing needs locks etc. not quite done. */
	int  read_start_ptr;  /* 0 for standard slots, variable for streams */
	int  read_end_ptr;    /* where data can be written next */

	int  write_start_ptr; /* 0 for standard slots, variable for streams */
	int  write_end_ptr;   /* where data can be written next */

	int  read_size;
	int  write_size;

#if HAVE_POSIX_SHARED_MEMORY
	sem_t read_lock;
	sem_t write_lock;
#endif

	unsigned char read_update_flag;
	unsigned char write_update_flag;

	char unused[2];
} gsi_shm_t;

struct gsi_shm_block {
	gsi_shm_t shm_header;
	void *shm_data;
	int  shm_data_length;
};
#endif /* USE_SYSV_SHARED_MEMORY */


#endif /* _GSI__gsi__gsi_shm_h */
